=== debian/changelog ===
ros-melodic-qpmad (1.0.2-1stretch) stretch; urgency=high

  * Added missing dependency in package.xml.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 30 Dec 2019 23:00:00 -0000

ros-melodic-qpmad (1.0.1-1stretch) stretch; urgency=high

  * Doxygen documentation.
  * Initial ROS release.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 23 Dec 2019 23:00:00 -0000
