=== debian/control ===
Source: ros-melodic-qpmad
Section: misc
Priority: optional
Maintainer: Alexander Sherikov <asherikov@yandex.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev
Homepage: https://github.com/asherikov/qpmad
Standards-Version: 3.9.2

Package: ros-melodic-qpmad
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: qpmad QP solver
